class com.kaboose.games.flagbricks.GameInfo
{
   var snd;
   var rowDrop;
   var sndNextRow;
   var gameMusic;
   var Hud;
   var matchPointTimer;
   var spawnTile;
   var nextRow;
   var levelInfo;
   static var _instance;
   var delegate = mx.utils.Delegate.create;
   var bGamePaused = false;
   var matchPointTimerObj = [];
   var matchPointTimerTime = 20;
   var bMatchPointTimerStarted = false;
   var spawnTileObj = [];
   var nextRowObj = [];
   var spawnTileTime = 1.2;
   var nextRowTime = 5;
   var bWaitingForNextRow = false;
   var bNextRowDir = false;
   var currentLevel = 1;
   var playerScore = 0;
   function GameInfo()
   {
      com.kaboose.games.flagbricks.GameInfo._instance = this;
      this.snd = com.kaboose.games.flagbricks.SoundManager._instance;
      this.rowDrop = this.snd.createSound("Throw1");
      this.sndNextRow = this.snd.createSound("Breathing1");
      this.gameMusic = this.snd.createSound("Forever1");
      this.gameMusic.setVolume(30);
      this.gameMusic.start(0,999);
      this.Hud = com.kaboose.games.flagbricks.GameLayers._instance.Hud.attachMovie("GameHud","GameHud",1000);
      this.Hud.subscribe(this);
      this.Hud.setLevel(this.currentLevel);
      com.kaboose.games.flagbricks.KeyEvents.subscribe(this);
      this.matchPointTimer = new mx.transitions.Tween(this.matchPointTimerObj,"",mx.transitions.easing.None.easeNone,100,50,this.matchPointTimerTime,true);
      this.matchPointTimer.onMotionChanged = this.delegate(this,this.matchPointTimerChanged);
      this.matchPointTimer.stop();
      this.spawnTile = new mx.transitions.Tween(this.spawnTileObj,"",mx.transitions.easing.None.easeNone,0,1,this.spawnTileTime,true);
      this.spawnTile.onMotionFinished = this.delegate(this,this.spawnTileFinished);
      this.spawnTile.stop();
      this.nextRow = new mx.transitions.Tween(this.nextRowObj,"",mx.transitions.easing.None.easeNone,0,100,this.nextRowTime,true);
      this.nextRow.onMotionFinished = this.delegate(this,this.nextRowDone);
      this.nextRow.onMotionChanged = this.delegate(this,this.nextRowChange);
      this.nextRow.stop();
      this.levelInfo = new com.kaboose.games.flagbricks.LevelInfo(this.Hud);
   }
   function startGame()
   {
      com.kaboose.games.flagbricks.MatchManager.reset();
      this.bMatchPointTimerStarted = false;
      this.Hud.enableButtons();
      this.Hud.nextRowIndicator.gotoAndStop(1);
      this.spawnTile.start();
   }
   function endGame()
   {
      this.matchPointTimer.stop();
      this.spawnTile.stop();
      this.nextRow.stop();
      this.levelInfo.disableFlags();
      this.Hud.showGameOver();
      this.snd.fadeOut(this.gameMusic);
      this.playerScore = this.Hud.score;
   }
   function matchPointTimerChanged()
   {
      this.Hud.setMatchPoints(Math.round(this.matchPointTimer._pos));
   }
   function restartMatchPointTimer()
   {
      this.matchPointTimer.start();
   }
   function spawnTileFinished()
   {
      if(this.levelInfo.insertNewTile())
      {
         this.nextRow.start();
         this.sndNextRow.start();
         this.bWaitingForNextRow = true;
         if(this.levelInfo.bMatchAreaFull())
         {
            this.endGame();
         }
         return undefined;
      }
      this.spawnTile.start();
   }
   function nextRowChange()
   {
      var _loc2_ = this.Hud.nextRowIndicator;
      if(this.bNextRowDir)
      {
         _loc2_.gotoAndStop(100 + Math.round(this.nextRow._pos));
      }
      else
      {
         _loc2_.gotoAndStop(Math.round(this.nextRow._pos));
      }
   }
   function nextRowDone()
   {
      var _loc2_ = this.Hud.nextRowIndicator;
      this.bWaitingForNextRow = false;
      if(_loc2_._currentframe == 100)
      {
         _loc2_.gotoAndStop(101);
         this.bNextRowDir = true;
      }
      else
      {
         _loc2_.gotoAndStop(1);
         this.bNextRowDir = false;
      }
      if(!this.bMatchPointTimerStarted)
      {
         this.matchPointTimer.start();
         this.bMatchPointTimerStarted = true;
      }
      this.levelInfo.resetPreview();
      this.rowDrop.start();
      this.spawnTile.start();
   }
   function levelCompleted()
   {
      this.playerScore = this.Hud.score;
      this.matchPointTimer.stop();
      this.spawnTile.stop();
      this.nextRow.stop();
      this.Hud.showLevelCompleted();
   }
   function nextLevel()
   {
      this.currentLevel += 1;
      this.Hud.setLevel(this.currentLevel);
      this.Hud.setMatchesLeft(2 + this.currentLevel);
      this.levelInfo.destroy();
      this.startGame();
   }
   function pause()
   {
      this.matchPointTimer.stop();
      this.spawnTile.stop();
      this.nextRow.stop();
      this.levelInfo.pause();
   }
   function resume()
   {
      if(!this.bWaitingForNextRow)
      {
         this.spawnTile.resume();
      }
      if(this.bWaitingForNextRow)
      {
         this.nextRow.resume();
      }
      if(this.bMatchPointTimerStarted)
      {
         this.matchPointTimer.resume();
      }
      this.levelInfo.resume();
   }
   function destroy()
   {
      trace("destroying game.");
      _global.flagbricksPlayerScore = this.playerScore;
      this.levelInfo.destroy();
      this.Hud.destroy();
      for(var _loc3_ in this)
      {
         delete this[_loc3_];
      }
      delete com.kaboose.games.flagbricks.GameInfo._instance;
   }
}
