class com.kaboose.games.flagbricks.LevelInfo
{
   var matchArray;
   var previewArray;
   var MAX_COLS = 6;
   var MAX_ROWS = 9;
   function LevelInfo()
   {
      com.kaboose.games.flagbricks.MatchManager.subscribe(this);
      this.reset();
   }
   function bMatchAreaFull()
   {
      var _loc2_ = 0;
      while(_loc2_ < this.MAX_COLS)
      {
         if(this.matchArray[_loc2_].length >= this.MAX_ROWS)
         {
            return true;
         }
         _loc2_ = _loc2_ + 1;
      }
   }
   function insertNewTile()
   {
      if(this.previewArray.length >= this.MAX_COLS)
      {
         return true;
      }
      this.previewArray.push(new com.kaboose.games.flagbricks.tiles.PreviewTile({index:this.previewArray.length,libRef:"brick_" + Math.round(Math.random() * 14)}));
   }
   function resetPreview()
   {
      var _loc3_ = 0;
      while(_loc3_ < this.MAX_COLS)
      {
         var _loc4_ = new com.kaboose.games.flagbricks.tiles.MatchTile({col:0,row:_loc3_,libRef:this.previewArray[_loc3_].getLibRef()});
         this.matchArray[_loc3_].unshift(_loc4_);
         this.previewArray[_loc3_].destroy();
         _loc3_ = _loc3_ + 1;
      }
      _loc3_ = 0;
      while(_loc3_ < this.MAX_COLS)
      {
         var _loc2_ = 0;
         while(_loc2_ < this.matchArray[_loc3_].length)
         {
            this.matchArray[_loc3_][_loc2_].anim.continueTo(_loc2_ * 40);
            _loc2_ = _loc2_ + 1;
         }
         _loc3_ = _loc3_ + 1;
      }
      this.previewArray = [];
   }
   function removeMatch(tileObj)
   {
      var _loc3_ = 0;
      while(_loc3_ < this.matchArray.length)
      {
         var _loc2_ = 0;
         while(_loc2_ < this.matchArray[_loc3_].length)
         {
            if(this.matchArray[_loc3_][_loc2_].mc._name == tileObj.mc._name)
            {
               this.matchArray[_loc3_][_loc2_].destroy();
               this.matchArray[_loc3_].splice(_loc2_,1);
               break;
            }
            _loc2_ = _loc2_ + 1;
         }
         _loc3_ = _loc3_ + 1;
      }
      _loc3_ = 0;
      while(_loc3_ < this.MAX_COLS)
      {
         _loc2_ = 0;
         while(_loc2_ < this.matchArray[_loc3_].length)
         {
            this.matchArray[_loc3_][_loc2_].anim.continueTo(_loc2_ * 40);
            _loc2_ = _loc2_ + 1;
         }
         _loc3_ = _loc3_ + 1;
      }
   }
   function removeRows(tileA, tileB)
   {
      var _loc7_ = [];
      var _loc8_ = [];
      var _loc6_ = 0;
      while(_loc6_ < this.MAX_COLS)
      {
         var _loc2_ = 0;
         while(_loc2_ < this.matchArray[_loc6_].length)
         {
            if(this.matchArray[_loc6_][_loc2_].mc == tileA.mc)
            {
               _loc7_ = {r:_loc6_,c:_loc2_};
            }
            if(this.matchArray[_loc6_][_loc2_].mc == tileB.mc)
            {
               _loc8_ = {r:_loc6_,c:_loc2_};
            }
            _loc2_ = _loc2_ + 1;
         }
         _loc6_ = _loc6_ + 1;
      }
      var _loc4_ = _loc7_.c >= _loc8_.c ? _loc8_ : _loc7_;
      var _loc12_ = _loc4_ != _loc7_ ? _loc7_ : _loc8_;
      var _loc11_ = _loc4_.r + (_loc12_.r - _loc4_.r);
      trace(_loc4_.r + "/" + _loc11_);
      _loc6_ = _loc4_.r;
      while(_loc4_ < _loc11_)
      {
         this.matchArray[_loc4_.c][_loc6_].mc._alpha = 10;
         _loc6_ = _loc6_ + 1;
      }
   }
   function getMatchAreaBonus()
   {
      var _loc3_ = 0;
      var _loc2_ = 0;
      while(_loc2_ < this.MAX_COLS)
      {
         _loc3_ = this.matchArray[_loc2_].length <= _loc3_ ? _loc3_ : this.matchArray[_loc2_].length;
         _loc2_ = _loc2_ + 1;
      }
      return this.MAX_ROWS - _loc3_;
   }
   function disableFlags()
   {
      var _loc3_ = 0;
      while(_loc3_ < this.matchArray.length)
      {
         var _loc2_ = 0;
         while(_loc2_ < this.matchArray[_loc3_].length)
         {
            this.matchArray[_loc3_][_loc2_].slider.enabled = false;
            _loc2_ = _loc2_ + 1;
         }
         _loc3_ = _loc3_ + 1;
      }
   }
   function pause()
   {
      var _loc3_ = 0;
      while(_loc3_ < this.previewArray.length)
      {
         this.previewArray[_loc3_].pause();
         _loc3_ = _loc3_ + 1;
      }
      _loc3_ = 0;
      while(_loc3_ < this.matchArray.length)
      {
         var _loc2_ = 0;
         while(_loc2_ < this.matchArray[_loc3_].length)
         {
            this.matchArray[_loc3_][_loc2_].pause();
            _loc2_ = _loc2_ + 1;
         }
         _loc3_ = _loc3_ + 1;
      }
   }
   function resume()
   {
      var _loc3_ = 0;
      while(_loc3_ < this.previewArray.length)
      {
         this.previewArray[_loc3_].resume();
         _loc3_ = _loc3_ + 1;
      }
      _loc3_ = 0;
      while(_loc3_ < this.matchArray.length)
      {
         var _loc2_ = 0;
         while(_loc2_ < this.matchArray[_loc3_].length)
         {
            this.matchArray[_loc3_][_loc2_].resume();
            _loc2_ = _loc2_ + 1;
         }
         _loc3_ = _loc3_ + 1;
      }
   }
   function destroy()
   {
      trace("destroying all tiles");
      var _loc3_ = 0;
      while(_loc3_ < this.MAX_COLS)
      {
         this.previewArray[_loc3_].destroy();
         _loc3_ = _loc3_ + 1;
      }
      _loc3_ = 0;
      while(_loc3_ < this.MAX_COLS)
      {
         var _loc2_ = 0;
         while(_loc2_ < this.MAX_ROWS)
         {
            this.matchArray[_loc3_][_loc2_].destroy();
            _loc2_ = _loc2_ + 1;
         }
         _loc3_ = _loc3_ + 1;
      }
      this.reset();
   }
   function reset()
   {
      trace("reset");
      this.previewArray = Array();
      this.matchArray = Array();
      var _loc2_ = 0;
      while(_loc2_ < this.MAX_COLS)
      {
         this.matchArray[_loc2_] = Array();
         _loc2_ = _loc2_ + 1;
      }
   }
}
