class com.kaboose.games.flagbricks.tiles.MatchTile extends com.kaboose.games.flagbricks.tiles.TileBase
{
   var mc;
   var slider;
   var flag;
   var sliderAnim;
   var enabled;
   var anim;
   var revert;
   var snd;
   var bReverting;
   var pauseDelta;
   var pauseStartTime;
   var easeStyle = mx.transitions.easing.Strong.easeOut;
   var animTime = 0.75;
   var sliderAnimSpeed = 0.25;
   var defaultWaitTime = 500;
   function MatchTile(tile)
   {
      super();
      this.mc = this.tileMC(com.kaboose.games.flagbricks.GameHud._instance.getMatchContainer(),tile.libRef);
      this.mc._x = this.tileW * tile.row;
      this.slider = this.mc.slider;
      this.flag = this.mc.flag;
      this.sliderAnim = new mx.transitions.Tween(this.slider,"_width",this.easeStyle,this.tileW,0,this.sliderAnimSpeed,true);
      this.sliderAnim.continueTo(this.tileW,0.01);
      var instance = this;
      this.slider.onPress = function()
      {
         if(!com.kaboose.games.flagbricks.MatchManager.check(instance))
         {
            return;
         }
         instance.snd.playSound("XurIncoming");
         this.enabled = false;
         instance.flag._visible = true;
         instance.pauseStartTime = getTimer();
         instance.bReverting = true;
         instance.sliderAnim.continueTo(0,instance.sliderAnimSpeed);
      };
      this.anim.begin = -40;
      this.anim.finish = this.tileH * tile.col;
      this.anim.start();
   }
   function flagName()
   {
      return this.mc.libRef;
   }
   function close(resumeTime, playCloseSnd)
   {
      if(resumeTime == undefined)
      {
         resumeTime = this.defaultWaitTime;
      }
      clearInterval(this.revert);
      this.revert = setInterval(function(t)
      {
         if(playCloseSnd)
         {
            t.snd.playSound("XurOutgoing");
         }
         t.sliderAnim.continueTo(t.tileW,this.sliderAnimSpeed);
         t.slider.enabled = true;
         t.bReverting = false;
         com.kaboose.games.flagbricks.MatchManager.reset();
         clearInterval(t.revert);
      }
      ,resumeTime,this);
   }
   function matchedTile(bCall, sndID)
   {
      if(sndID >= 3)
      {
         sndID = 3;
      }
      if(bCall)
      {
         switch(sndID)
         {
            case 1:
               this.snd.playSound("Pickmeup1");
               break;
            case 2:
               this.snd.playSound("Pickmeup2");
               break;
            case 3:
               this.snd.playSound("Pickmeup3");
         }
      }
      var destroyClip = setInterval(function(mt)
      {
         if(bCall)
         {
            com.kaboose.games.flagbricks.GameHud._instance.setScore(sndID);
            com.kaboose.games.flagbricks.MatchManager.clearMatch();
         }
         clearInterval(destroyClip);
      }
      ,250,this);
   }
   function spawnSparkle()
   {
      this.mc.attachMovie("sparkle","sparkle",this.mc.getNextHighestDepth());
   }
   function pause()
   {
      if(this.bReverting)
      {
         clearInterval(this.revert);
         this.pauseDelta = this.defaultWaitTime - (getTimer() - this.pauseStartTime);
      }
      this.sliderAnim.stop();
      this.anim.stop();
   }
   function resume()
   {
      if(this.bReverting)
      {
         this.close(this.pauseDelta);
      }
      this.sliderAnim.resume();
      this.anim.resume();
   }
   function destroy()
   {
      super.destroy();
      false;
   }
   function updateposition()
   {
      this.mc._y = this.anim._pos;
   }
}
