class com.kaboose.games.flagbricks.ui.MainMenu extends MovieClip
{
   var snd;
   var menuMusic;
   var rainSound;
   var skipIntro;
   var btnPlayGame;
   var btnHighScores;
   var btnInstructions;
   var btnTellAFriend;
   static var _instance;
   function MainMenu()
   {
      super();
      com.kaboose.games.flagbricks.ui.MainMenu._instance = this;
      this.snd = com.kaboose.games.flagbricks.SoundManager._instance;
      this.menuMusic = this.snd.createSound("lounge_09_red_cat_L1");
      this.rainSound = this.snd.createSound("Raining");
      this.rainSound.start();
      this.rainSound.setVolume(50);
      this.skipIntro.onRollOver = function()
      {
         com.kaboose.games.flagbricks.ui.MainMenu._instance.playRollOverSound();
      };
      this.skipIntro.onPress = function()
      {
         com.kaboose.games.flagbricks.ui.MainMenu._instance.gotoAndStop("mainMenu");
         com.kaboose.games.flagbricks.ui.MainMenu._instance.playClickSound();
      };
   }
   function playClickSound()
   {
      this.snd.playSound("Maxim");
   }
   function playRollOverSound()
   {
      this.snd.playSound("Bond");
   }
   function initMainMenu()
   {
      var _loc4_ = com.kaboose.games.flagbricks.ui.MenuBase._instance;
      this.snd.fadeOut(this.rainSound);
      this.menuMusic.start(0,999);
      this.menuMusic.setVolume(50);
      this.btnPlayGame.onRollOver = function()
      {
         com.kaboose.games.flagbricks.ui.MainMenu._instance.playRollOverSound();
      };
      this.btnPlayGame.onPress = function()
      {
         com.kaboose.games.flagbricks.ui.MainMenu._instance.spawnMenuRef = "playGame";
         com.kaboose.games.flagbricks.ui.MainMenu._instance.gotoAndPlay("animOut");
         com.kaboose.games.flagbricks.ui.MainMenu._instance.playClickSound();
      };
      this.btnHighScores.onRollOver = function()
      {
         com.kaboose.games.flagbricks.ui.MainMenu._instance.playRollOverSound();
      };
      this.btnHighScores.onPress = function()
      {
         com.kaboose.games.flagbricks.ui.MainMenu._instance.spawnMenu("highScoresScreen");
         com.kaboose.games.flagbricks.ui.MainMenu._instance.playClickSound();
         com.kaboose.games.flagbricks.ui.MainMenu._instance.enableButtons(false);
      };
      this.btnInstructions.onRollOver = function()
      {
         com.kaboose.games.flagbricks.ui.MainMenu._instance.playRollOverSound();
      };
      this.btnInstructions.onPress = function()
      {
         com.kaboose.games.flagbricks.ui.MainMenu._instance.spawnMenu("instructionsPage");
         com.kaboose.games.flagbricks.ui.MainMenu._instance.playClickSound();
         com.kaboose.games.flagbricks.ui.MainMenu._instance.enableButtons(false);
      };
      this.btnTellAFriend.onRollOver = function()
      {
         com.kaboose.games.flagbricks.ui.MainMenu._instance.playRollOverSound();
      };
      this.btnTellAFriend.onPress = function()
      {
         var _loc2_ = "javascript:openTellAFriendWindow(\'" + _root.tellURL + "\',450,550)";
         com.kaboose.games.flagbricks.ui.MainMenu._instance.getURL(_loc2_);
         com.kaboose.games.flagbricks.ui.MainMenu._instance.playClickSound();
      };
      this.stop();
   }
   function enableButtons(bEnabled)
   {
      this.btnPlayGame.enabled = bEnabled;
      this.btnHighScores.enabled = bEnabled;
      this.btnInstructions.enabled = bEnabled;
      this.btnTellAFriend.enabled = bEnabled;
   }
   function playAnimOut()
   {
      this.snd.fadeOut(this.menuMusic);
   }
   function spawnMenu(menuName)
   {
      if(menuName == "playGame")
      {
         com.kaboose.games.flagbricks.ui.MainMenu._instance.destroy();
         com.kaboose.games.flagbricks.ui.MenuBase._instance.playGame();
         return undefined;
      }
      this.attachMovie(menuName,menuName,1);
   }
   function destroy()
   {
      this.removeMovieClip();
   }
}
